<%@taglib prefix="itrust" uri="/WEB-INF/tags.tld"%>
<%@page errorPage="/auth/exceptionHandler.jsp"%>

<%@include file="/global.jsp"%>

<%
	pageTitle = "iTrust - Privacy Policy";
	loginMessage = "";
%>

<%@include file="/header.jsp"%>

<br />
<h3>iTrust Privacy Policy</h3>
Last modified: 11 April 2008
<hr>
<table border=0 cellpadding=5 >
	<tr valign=top>
		<td>
			<h3>Notice/Awareness</h3>
		</td>
		<td>
			This privacy policy complies with the Privacy Rule Standards
			set forth by the United States Department of Health and Human Services
			Office of Civil Rights - HIPPA.
			<p>Please review this privacy policy before using the iTrust
			system. This system was designed to collect and securely store
			Personally Identifiable Health Information (PIHI). Our goal is to
			ensure that we follow the Privacy Rules as stated by the USHHS. These
			privacy rules are in place to protect the privacy of individuals and
			their health care information, while allowing access and dissemination
			to medical professionals who need it to provide care.
			<hr>
		</td>
	</tr>

	<tr valign=top>
		<td>
			<h3>Choice/Consent</h3>
		</td>
		<td>
			The Privacy Rule states that obtaining written permission
			from an individual to collect and use their health information is
			optional. Therefore, it is our policy that we will collect and use
			your PIHI based on the categories and uses below. By using the iTrust
			system, you grant us permission to collect and store your information
			for the treatment and ongoing operations of our health practice. If
			you would prefer not to have your information available in the iTrust
			system, you must indicate so in writing to our offices.
			<p>As stated in the Privacy Rules we are permitted to use your
			PIHI in the following situations without written authorization:
			<ol>
				<li>Disclosure to the individual patient;
				<li>For treatment of sickness and diseases;
				<li>For the collection of payment for services rendered;
				<li>For the ongoing operation of this facility and our medical
				practice;
				<li>To provide an opportunity for the patient to agree or object
				to treatment options;
				<li>In a way that supports other permitted uses;
				<li>In ways that are beneficial to the public interest and
				public health care; and
				<li>In other limited ways for the purposes of research or public
				health.
			</ol>
			We rely on our judgment and generally accepted professional ethics to
			decide whether our actions are consistent with the above stated
			allowable uses. We will obtain written authorization from the patient
			or patient's authorized representative prior to disclosing any PIHI
			that is outside the scope of the above listed categories.
			<hr>
		</td>
	</tr>
	<tr valign=top>
		<td>
			<h3>Integrity/Security</h3>
		</td>
		<td>
			The integrity and security of your PIHI is very important to
			us. We strive to maintain the best security and access policies to
			prevent the accidental or intentional disclosure of information that
			would be in violation of the uses stated above.
			<hr>
		</td>
	</tr>
	<tr valign=top>
		<td>
			<h3>Access/Participation</h3>
		</td>
		<td>
			<p>
			The privacy policy requires us to allow you access to your
			medical records. Please contact the iTrust System Administrator our
			your medical professional if you feel any information is incorrect or
			needs to be changed.
			</p>
		</td>
	</tr>
</table>

<%@include file="/footer.jsp" %>
